#include <cstdlib>
#include <cstring>
using namespace std;
class Serializer
{
public:
   Serializer() : ptr(0), len(0), off(0) {}
   ~Serializer() { free(ptr); }

   template<typename T> void Serialize(T arg)
   {
      MakeSpace(sizeof(T));
      memcpy((char *)ptr + off, &arg, sizeof(T));
      off += sizeof(T);
   }
   template<typename T> void Serialize(T* arg, int num)
   {
      Serialize(num);
      MakeSpace(sizeof(T)*num);
      memcpy((char *)ptr + off, arg, sizeof(T)*num);
      off += sizeof(T)*num;
   }
   void *ptr;
   int len;
   int off;
   void MakeSpace(int bytes) { len += bytes; ptr = realloc(ptr, len); };
};

class Deserializer
{
public:
   Deserializer(void* p) : ptr(p), off(0) {}

   template<typename T> void Deserialize(T& arg)
   {
      memcpy((void *)&arg, (char *)ptr + off, sizeof(T));
      off += sizeof(T);
   }
   template<typename T> void Deserialize(T* arg)
   {
      int size;
      Deserialize(size);
      memcpy((void *)arg, (char *)ptr + off, sizeof(T)*size);
      off += sizeof(T)*size;
   }
   template<typename T> void DeserializePtr(T*& arg, int& size)
   {
      Deserialize(size);
      arg = new T[size];
      memcpy((void *)arg, (char *)ptr + off, sizeof(T)*size);
      off += sizeof(T)*size;
   }
   void *ptr;
   int off;
};
